/* Generated by ts-generator ver. 0.0.8 */
/* tslint:disable */

import {
  ethers,
  EventFilter,
  Signer,
  BigNumber,
  BigNumberish,
  PopulatedTransaction
} from "ethers";
import {
  Contract,
  ContractTransaction,
  Overrides,
  CallOverrides
} from "@ethersproject/contracts";
import { BytesLike } from "@ethersproject/bytes";
import { Listener, Provider } from "@ethersproject/providers";
import { FunctionFragment, EventFragment, Result } from "@ethersproject/abi";

interface Erc1155MetaInterface extends ethers.utils.Interface {
  functions: {
    "balanceOf(address,uint256)": FunctionFragment;
    "balanceOfBatch(address[],uint256[])": FunctionFragment;
    "isApprovedForAll(address,address)": FunctionFragment;
    "isValidSignature(address,bytes32,bytes,bytes)": FunctionFragment;
    "safeBatchTransferFrom(address,address,uint256[],uint256[],bytes)": FunctionFragment;
    "safeTransferFrom(address,address,uint256,uint256,bytes)": FunctionFragment;
    "setApprovalForAll(address,bool)": FunctionFragment;
    "supportsInterface(bytes4)": FunctionFragment;
    "metaSafeTransferFrom(address,address,uint256,uint256,bool,bytes)": FunctionFragment;
    "metaSafeBatchTransferFrom(address,address,uint256[],uint256[],bool,bytes)": FunctionFragment;
    "metaSetApprovalForAll(address,address,bool,bool,bytes)": FunctionFragment;
    "getNonce(address)": FunctionFragment;
  };

  encodeFunctionData(
    functionFragment: "balanceOf",
    values: [string, BigNumberish]
  ): string;
  encodeFunctionData(
    functionFragment: "balanceOfBatch",
    values: [(string)[], (BigNumberish)[]]
  ): string;
  encodeFunctionData(
    functionFragment: "isApprovedForAll",
    values: [string, string]
  ): string;
  encodeFunctionData(
    functionFragment: "isValidSignature",
    values: [string, BytesLike, BytesLike, BytesLike]
  ): string;
  encodeFunctionData(
    functionFragment: "safeBatchTransferFrom",
    values: [string, string, (BigNumberish)[], (BigNumberish)[], BytesLike]
  ): string;
  encodeFunctionData(
    functionFragment: "safeTransferFrom",
    values: [string, string, BigNumberish, BigNumberish, BytesLike]
  ): string;
  encodeFunctionData(
    functionFragment: "setApprovalForAll",
    values: [string, boolean]
  ): string;
  encodeFunctionData(
    functionFragment: "supportsInterface",
    values: [BytesLike]
  ): string;
  encodeFunctionData(
    functionFragment: "metaSafeTransferFrom",
    values: [string, string, BigNumberish, BigNumberish, boolean, BytesLike]
  ): string;
  encodeFunctionData(
    functionFragment: "metaSafeBatchTransferFrom",
    values: [
      string,
      string,
      (BigNumberish)[],
      (BigNumberish)[],
      boolean,
      BytesLike
    ]
  ): string;
  encodeFunctionData(
    functionFragment: "metaSetApprovalForAll",
    values: [string, string, boolean, boolean, BytesLike]
  ): string;
  encodeFunctionData(functionFragment: "getNonce", values: [string]): string;

  decodeFunctionResult(functionFragment: "balanceOf", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "balanceOfBatch",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "isApprovedForAll",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "isValidSignature",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "safeBatchTransferFrom",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "safeTransferFrom",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "setApprovalForAll",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "supportsInterface",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "metaSafeTransferFrom",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "metaSafeBatchTransferFrom",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "metaSetApprovalForAll",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "getNonce", data: BytesLike): Result;

  events: {
    "ApprovalForAll(address,address,bool)": EventFragment;
    "NonceChange(address,uint256)": EventFragment;
    "TransferBatch(address,address,address,uint256[],uint256[])": EventFragment;
    "TransferSingle(address,address,address,uint256,uint256)": EventFragment;
  };

  getEvent(nameOrSignatureOrTopic: "ApprovalForAll"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "NonceChange"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "TransferBatch"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "TransferSingle"): EventFragment;
}

export class Erc1155Meta extends Contract {
  connect(signerOrProvider: Signer | Provider | string): this;
  attach(addressOrName: string): this;
  deployed(): Promise<this>;

  on(event: EventFilter | string, listener: Listener): this;
  once(event: EventFilter | string, listener: Listener): this;
  addListener(eventName: EventFilter | string, listener: Listener): this;
  removeAllListeners(eventName: EventFilter | string): this;
  removeListener(eventName: any, listener: Listener): this;

  interface: Erc1155MetaInterface;

  functions: {
    /**
     * Get the balance of an account's Tokens
     * @param _id ID of the Token
     * @param _owner The address of the token holder
     */
    balanceOf(
      _owner: string,
      _id: BigNumberish,
      overrides?: CallOverrides
    ): Promise<{
      0: BigNumber;
    }>;

    /**
     * Get the balance of multiple account/token pairs
     * @param _ids ID of the Tokens
     * @param _owners The addresses of the token holders
     */
    balanceOfBatch(
      _owners: (string)[],
      _ids: (BigNumberish)[],
      overrides?: CallOverrides
    ): Promise<{
      0: (BigNumber)[];
    }>;

    /**
     * Queries the approval status of an operator for a given owner
     * @param _operator Address of authorized operator
     * @param _owner The owner of the Tokens
     */
    isApprovedForAll(
      _owner: string,
      _operator: string,
      overrides?: CallOverrides
    ): Promise<{
      isOperator: boolean;
      0: boolean;
    }>;

    /**
     * Verifies that a hash has been signed by the given signer.
     * @param _data Full EIP-712 data structure that was hashed and signed
     * @param _hash Hash of the EIP-712 encoded data
     * @param _sig Proof that the hash has been signed by signer.      For non wallet signatures, _sig is expected to be an array tightly encoded as      (bytes32 r, bytes32 s, uint8 v, uint256 nonce, SignatureType sigType)
     * @param _signerAddress Address that should have signed the given hash.
     */
    isValidSignature(
      _signerAddress: string,
      _hash: BytesLike,
      _data: BytesLike,
      _sig: BytesLike,
      overrides?: CallOverrides
    ): Promise<{
      isValid: boolean;
      0: boolean;
    }>;

    /**
     * Send multiple types of Tokens from the _from address to the _to address (with safety call)
     * @param _amounts Transfer amounts per token type
     * @param _data Additional data with no specified format, sent in call to `_to`
     * @param _from Source addresses
     * @param _ids IDs of each token type
     * @param _to Target addresses
     */
    safeBatchTransferFrom(
      _from: string,
      _to: string,
      _ids: (BigNumberish)[],
      _amounts: (BigNumberish)[],
      _data: BytesLike,
      overrides?: Overrides
    ): Promise<ContractTransaction>;

    /**
     * Transfers amount amount of an _id from the _from address to the _to address specified
     * @param _amount Transfered amount
     * @param _data Additional data with no specified format, sent in call to `_to`
     * @param _from Source address
     * @param _id ID of the token type
     * @param _to Target address
     */
    safeTransferFrom(
      _from: string,
      _to: string,
      _id: BigNumberish,
      _amount: BigNumberish,
      _data: BytesLike,
      overrides?: Overrides
    ): Promise<ContractTransaction>;

    /**
     * Enable or disable approval for a third party ("operator") to manage all of caller's tokens
     * @param _approved True if the operator is approved, false to revoke approval
     * @param _operator Address to add to the set of authorized operators
     */
    setApprovalForAll(
      _operator: string,
      _approved: boolean,
      overrides?: Overrides
    ): Promise<ContractTransaction>;

    /**
     * Query if a contract implements an interface
     * @param _interfaceID The interface identifier, as specified in ERC-165
     */
    supportsInterface(
      _interfaceID: BytesLike,
      overrides?: CallOverrides
    ): Promise<{
      0: boolean;
    }>;

    /**
     * Allows anyone with a valid signature to transfer _amount amount of a token _id on the bahalf of _from
     * @param _amount Transfered amount
     * @param _data Encodes a meta transfer indicator, signature, gas payment receipt and extra transfer data   _data should be encoded as (   (bytes32 r, bytes32 s, uint8 v, uint256 nonce, SignatureType sigType),   (GasReceipt g, ?bytes transferData) )   i.e. high level encoding should be (bytes, bytes), where the latter bytes array is a nested bytes array
     * @param _from Source address
     * @param _id ID of the token type
     * @param _isGasFee Whether gas is reimbursed to executor or not
     * @param _to Target address
     */
    metaSafeTransferFrom(
      _from: string,
      _to: string,
      _id: BigNumberish,
      _amount: BigNumberish,
      _isGasFee: boolean,
      _data: BytesLike,
      overrides?: Overrides
    ): Promise<ContractTransaction>;

    /**
     * Allows anyone with a valid signature to transfer multiple types of tokens on the bahalf of _from
     * @param _amounts Transfer amounts per token type
     * @param _data Encodes a meta transfer indicator, signature, gas payment receipt and extra transfer data   _data should be encoded as (   (bytes32 r, bytes32 s, uint8 v, uint256 nonce, SignatureType sigType),   (GasReceipt g, ?bytes transferData) )   i.e. high level encoding should be (bytes, bytes), where the latter bytes array is a nested bytes array
     * @param _from Source addresses
     * @param _ids IDs of each token type
     * @param _isGasFee Whether gas is reimbursed to executor or not
     * @param _to Target addresses
     */
    metaSafeBatchTransferFrom(
      _from: string,
      _to: string,
      _ids: (BigNumberish)[],
      _amounts: (BigNumberish)[],
      _isGasFee: boolean,
      _data: BytesLike,
      overrides?: Overrides
    ): Promise<ContractTransaction>;

    /**
     * Approve the passed address to spend on behalf of _from if valid signature is provided
     * @param _approved True if the operator is approved, false to revoke approval
     * @param _data Encodes signature and gas payment receipt   _data should be encoded as (     (bytes32 r, bytes32 s, uint8 v, uint256 nonce, SignatureType sigType),     (GasReceipt g)   )   i.e. high level encoding should be (bytes, bytes), where the latter bytes array is a nested bytes array
     * @param _isGasFee Whether gas will be reimbursed or not, with vlid signature
     * @param _operator Address to add to the set of authorized operators
     * @param _owner Address that wants to set operator status  _spender
     */
    metaSetApprovalForAll(
      _owner: string,
      _operator: string,
      _approved: boolean,
      _isGasFee: boolean,
      _data: BytesLike,
      overrides?: Overrides
    ): Promise<ContractTransaction>;

    /**
     * Returns the current nonce associated with a given address
     * @param _signer Address to query signature nonce for
     */
    getNonce(
      _signer: string,
      overrides?: CallOverrides
    ): Promise<{
      nonce: BigNumber;
      0: BigNumber;
    }>;
  };

  /**
   * Get the balance of an account's Tokens
   * @param _id ID of the Token
   * @param _owner The address of the token holder
   */
  balanceOf(
    _owner: string,
    _id: BigNumberish,
    overrides?: CallOverrides
  ): Promise<BigNumber>;

  /**
   * Get the balance of multiple account/token pairs
   * @param _ids ID of the Tokens
   * @param _owners The addresses of the token holders
   */
  balanceOfBatch(
    _owners: (string)[],
    _ids: (BigNumberish)[],
    overrides?: CallOverrides
  ): Promise<(BigNumber)[]>;

  /**
   * Queries the approval status of an operator for a given owner
   * @param _operator Address of authorized operator
   * @param _owner The owner of the Tokens
   */
  isApprovedForAll(
    _owner: string,
    _operator: string,
    overrides?: CallOverrides
  ): Promise<boolean>;

  /**
   * Verifies that a hash has been signed by the given signer.
   * @param _data Full EIP-712 data structure that was hashed and signed
   * @param _hash Hash of the EIP-712 encoded data
   * @param _sig Proof that the hash has been signed by signer.      For non wallet signatures, _sig is expected to be an array tightly encoded as      (bytes32 r, bytes32 s, uint8 v, uint256 nonce, SignatureType sigType)
   * @param _signerAddress Address that should have signed the given hash.
   */
  isValidSignature(
    _signerAddress: string,
    _hash: BytesLike,
    _data: BytesLike,
    _sig: BytesLike,
    overrides?: CallOverrides
  ): Promise<boolean>;

  /**
   * Send multiple types of Tokens from the _from address to the _to address (with safety call)
   * @param _amounts Transfer amounts per token type
   * @param _data Additional data with no specified format, sent in call to `_to`
   * @param _from Source addresses
   * @param _ids IDs of each token type
   * @param _to Target addresses
   */
  safeBatchTransferFrom(
    _from: string,
    _to: string,
    _ids: (BigNumberish)[],
    _amounts: (BigNumberish)[],
    _data: BytesLike,
    overrides?: Overrides
  ): Promise<ContractTransaction>;

  /**
   * Transfers amount amount of an _id from the _from address to the _to address specified
   * @param _amount Transfered amount
   * @param _data Additional data with no specified format, sent in call to `_to`
   * @param _from Source address
   * @param _id ID of the token type
   * @param _to Target address
   */
  safeTransferFrom(
    _from: string,
    _to: string,
    _id: BigNumberish,
    _amount: BigNumberish,
    _data: BytesLike,
    overrides?: Overrides
  ): Promise<ContractTransaction>;

  /**
   * Enable or disable approval for a third party ("operator") to manage all of caller's tokens
   * @param _approved True if the operator is approved, false to revoke approval
   * @param _operator Address to add to the set of authorized operators
   */
  setApprovalForAll(
    _operator: string,
    _approved: boolean,
    overrides?: Overrides
  ): Promise<ContractTransaction>;

  /**
   * Query if a contract implements an interface
   * @param _interfaceID The interface identifier, as specified in ERC-165
   */
  supportsInterface(
    _interfaceID: BytesLike,
    overrides?: CallOverrides
  ): Promise<boolean>;

  /**
   * Allows anyone with a valid signature to transfer _amount amount of a token _id on the bahalf of _from
   * @param _amount Transfered amount
   * @param _data Encodes a meta transfer indicator, signature, gas payment receipt and extra transfer data   _data should be encoded as (   (bytes32 r, bytes32 s, uint8 v, uint256 nonce, SignatureType sigType),   (GasReceipt g, ?bytes transferData) )   i.e. high level encoding should be (bytes, bytes), where the latter bytes array is a nested bytes array
   * @param _from Source address
   * @param _id ID of the token type
   * @param _isGasFee Whether gas is reimbursed to executor or not
   * @param _to Target address
   */
  metaSafeTransferFrom(
    _from: string,
    _to: string,
    _id: BigNumberish,
    _amount: BigNumberish,
    _isGasFee: boolean,
    _data: BytesLike,
    overrides?: Overrides
  ): Promise<ContractTransaction>;

  /**
   * Allows anyone with a valid signature to transfer multiple types of tokens on the bahalf of _from
   * @param _amounts Transfer amounts per token type
   * @param _data Encodes a meta transfer indicator, signature, gas payment receipt and extra transfer data   _data should be encoded as (   (bytes32 r, bytes32 s, uint8 v, uint256 nonce, SignatureType sigType),   (GasReceipt g, ?bytes transferData) )   i.e. high level encoding should be (bytes, bytes), where the latter bytes array is a nested bytes array
   * @param _from Source addresses
   * @param _ids IDs of each token type
   * @param _isGasFee Whether gas is reimbursed to executor or not
   * @param _to Target addresses
   */
  metaSafeBatchTransferFrom(
    _from: string,
    _to: string,
    _ids: (BigNumberish)[],
    _amounts: (BigNumberish)[],
    _isGasFee: boolean,
    _data: BytesLike,
    overrides?: Overrides
  ): Promise<ContractTransaction>;

  /**
   * Approve the passed address to spend on behalf of _from if valid signature is provided
   * @param _approved True if the operator is approved, false to revoke approval
   * @param _data Encodes signature and gas payment receipt   _data should be encoded as (     (bytes32 r, bytes32 s, uint8 v, uint256 nonce, SignatureType sigType),     (GasReceipt g)   )   i.e. high level encoding should be (bytes, bytes), where the latter bytes array is a nested bytes array
   * @param _isGasFee Whether gas will be reimbursed or not, with vlid signature
   * @param _operator Address to add to the set of authorized operators
   * @param _owner Address that wants to set operator status  _spender
   */
  metaSetApprovalForAll(
    _owner: string,
    _operator: string,
    _approved: boolean,
    _isGasFee: boolean,
    _data: BytesLike,
    overrides?: Overrides
  ): Promise<ContractTransaction>;

  /**
   * Returns the current nonce associated with a given address
   * @param _signer Address to query signature nonce for
   */
  getNonce(_signer: string, overrides?: CallOverrides): Promise<BigNumber>;

  staticCall: {
    /**
     * Get the balance of an account's Tokens
     * @param _id ID of the Token
     * @param _owner The address of the token holder
     */
    balanceOf(
      _owner: string,
      _id: BigNumberish,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    /**
     * Get the balance of multiple account/token pairs
     * @param _ids ID of the Tokens
     * @param _owners The addresses of the token holders
     */
    balanceOfBatch(
      _owners: (string)[],
      _ids: (BigNumberish)[],
      overrides?: CallOverrides
    ): Promise<(BigNumber)[]>;

    /**
     * Queries the approval status of an operator for a given owner
     * @param _operator Address of authorized operator
     * @param _owner The owner of the Tokens
     */
    isApprovedForAll(
      _owner: string,
      _operator: string,
      overrides?: CallOverrides
    ): Promise<boolean>;

    /**
     * Verifies that a hash has been signed by the given signer.
     * @param _data Full EIP-712 data structure that was hashed and signed
     * @param _hash Hash of the EIP-712 encoded data
     * @param _sig Proof that the hash has been signed by signer.      For non wallet signatures, _sig is expected to be an array tightly encoded as      (bytes32 r, bytes32 s, uint8 v, uint256 nonce, SignatureType sigType)
     * @param _signerAddress Address that should have signed the given hash.
     */
    isValidSignature(
      _signerAddress: string,
      _hash: BytesLike,
      _data: BytesLike,
      _sig: BytesLike,
      overrides?: CallOverrides
    ): Promise<boolean>;

    /**
     * Send multiple types of Tokens from the _from address to the _to address (with safety call)
     * @param _amounts Transfer amounts per token type
     * @param _data Additional data with no specified format, sent in call to `_to`
     * @param _from Source addresses
     * @param _ids IDs of each token type
     * @param _to Target addresses
     */
    safeBatchTransferFrom(
      _from: string,
      _to: string,
      _ids: (BigNumberish)[],
      _amounts: (BigNumberish)[],
      _data: BytesLike,
      overrides?: Overrides
    ): Promise<void>;

    /**
     * Transfers amount amount of an _id from the _from address to the _to address specified
     * @param _amount Transfered amount
     * @param _data Additional data with no specified format, sent in call to `_to`
     * @param _from Source address
     * @param _id ID of the token type
     * @param _to Target address
     */
    safeTransferFrom(
      _from: string,
      _to: string,
      _id: BigNumberish,
      _amount: BigNumberish,
      _data: BytesLike,
      overrides?: Overrides
    ): Promise<void>;

    /**
     * Enable or disable approval for a third party ("operator") to manage all of caller's tokens
     * @param _approved True if the operator is approved, false to revoke approval
     * @param _operator Address to add to the set of authorized operators
     */
    setApprovalForAll(
      _operator: string,
      _approved: boolean,
      overrides?: Overrides
    ): Promise<void>;

    /**
     * Query if a contract implements an interface
     * @param _interfaceID The interface identifier, as specified in ERC-165
     */
    supportsInterface(
      _interfaceID: BytesLike,
      overrides?: CallOverrides
    ): Promise<boolean>;

    /**
     * Allows anyone with a valid signature to transfer _amount amount of a token _id on the bahalf of _from
     * @param _amount Transfered amount
     * @param _data Encodes a meta transfer indicator, signature, gas payment receipt and extra transfer data   _data should be encoded as (   (bytes32 r, bytes32 s, uint8 v, uint256 nonce, SignatureType sigType),   (GasReceipt g, ?bytes transferData) )   i.e. high level encoding should be (bytes, bytes), where the latter bytes array is a nested bytes array
     * @param _from Source address
     * @param _id ID of the token type
     * @param _isGasFee Whether gas is reimbursed to executor or not
     * @param _to Target address
     */
    metaSafeTransferFrom(
      _from: string,
      _to: string,
      _id: BigNumberish,
      _amount: BigNumberish,
      _isGasFee: boolean,
      _data: BytesLike,
      overrides?: Overrides
    ): Promise<void>;

    /**
     * Allows anyone with a valid signature to transfer multiple types of tokens on the bahalf of _from
     * @param _amounts Transfer amounts per token type
     * @param _data Encodes a meta transfer indicator, signature, gas payment receipt and extra transfer data   _data should be encoded as (   (bytes32 r, bytes32 s, uint8 v, uint256 nonce, SignatureType sigType),   (GasReceipt g, ?bytes transferData) )   i.e. high level encoding should be (bytes, bytes), where the latter bytes array is a nested bytes array
     * @param _from Source addresses
     * @param _ids IDs of each token type
     * @param _isGasFee Whether gas is reimbursed to executor or not
     * @param _to Target addresses
     */
    metaSafeBatchTransferFrom(
      _from: string,
      _to: string,
      _ids: (BigNumberish)[],
      _amounts: (BigNumberish)[],
      _isGasFee: boolean,
      _data: BytesLike,
      overrides?: Overrides
    ): Promise<void>;

    /**
     * Approve the passed address to spend on behalf of _from if valid signature is provided
     * @param _approved True if the operator is approved, false to revoke approval
     * @param _data Encodes signature and gas payment receipt   _data should be encoded as (     (bytes32 r, bytes32 s, uint8 v, uint256 nonce, SignatureType sigType),     (GasReceipt g)   )   i.e. high level encoding should be (bytes, bytes), where the latter bytes array is a nested bytes array
     * @param _isGasFee Whether gas will be reimbursed or not, with vlid signature
     * @param _operator Address to add to the set of authorized operators
     * @param _owner Address that wants to set operator status  _spender
     */
    metaSetApprovalForAll(
      _owner: string,
      _operator: string,
      _approved: boolean,
      _isGasFee: boolean,
      _data: BytesLike,
      overrides?: Overrides
    ): Promise<void>;

    /**
     * Returns the current nonce associated with a given address
     * @param _signer Address to query signature nonce for
     */
    getNonce(_signer: string, overrides?: CallOverrides): Promise<BigNumber>;
  };

  filters: {
    ApprovalForAll(
      _owner: string | null,
      _operator: string | null,
      _approved: null
    ): EventFilter;

    NonceChange(signer: string | null, newNonce: null): EventFilter;

    TransferBatch(
      _operator: string | null,
      _from: string | null,
      _to: string | null,
      _ids: null,
      _amounts: null
    ): EventFilter;

    TransferSingle(
      _operator: string | null,
      _from: string | null,
      _to: string | null,
      _id: null,
      _amount: null
    ): EventFilter;
  };

  estimateGas: {
    balanceOf(_owner: string, _id: BigNumberish): Promise<BigNumber>;
    balanceOfBatch(
      _owners: (string)[],
      _ids: (BigNumberish)[]
    ): Promise<BigNumber>;
    isApprovedForAll(_owner: string, _operator: string): Promise<BigNumber>;
    isValidSignature(
      _signerAddress: string,
      _hash: BytesLike,
      _data: BytesLike,
      _sig: BytesLike
    ): Promise<BigNumber>;
    safeBatchTransferFrom(
      _from: string,
      _to: string,
      _ids: (BigNumberish)[],
      _amounts: (BigNumberish)[],
      _data: BytesLike
    ): Promise<BigNumber>;
    safeTransferFrom(
      _from: string,
      _to: string,
      _id: BigNumberish,
      _amount: BigNumberish,
      _data: BytesLike
    ): Promise<BigNumber>;
    setApprovalForAll(
      _operator: string,
      _approved: boolean
    ): Promise<BigNumber>;
    supportsInterface(_interfaceID: BytesLike): Promise<BigNumber>;
    metaSafeTransferFrom(
      _from: string,
      _to: string,
      _id: BigNumberish,
      _amount: BigNumberish,
      _isGasFee: boolean,
      _data: BytesLike
    ): Promise<BigNumber>;
    metaSafeBatchTransferFrom(
      _from: string,
      _to: string,
      _ids: (BigNumberish)[],
      _amounts: (BigNumberish)[],
      _isGasFee: boolean,
      _data: BytesLike
    ): Promise<BigNumber>;
    metaSetApprovalForAll(
      _owner: string,
      _operator: string,
      _approved: boolean,
      _isGasFee: boolean,
      _data: BytesLike
    ): Promise<BigNumber>;
    getNonce(_signer: string): Promise<BigNumber>;
  };

  populateTransaction: {
    balanceOf(_owner: string, _id: BigNumberish): Promise<PopulatedTransaction>;
    balanceOfBatch(
      _owners: (string)[],
      _ids: (BigNumberish)[]
    ): Promise<PopulatedTransaction>;
    isApprovedForAll(
      _owner: string,
      _operator: string
    ): Promise<PopulatedTransaction>;
    isValidSignature(
      _signerAddress: string,
      _hash: BytesLike,
      _data: BytesLike,
      _sig: BytesLike
    ): Promise<PopulatedTransaction>;
    safeBatchTransferFrom(
      _from: string,
      _to: string,
      _ids: (BigNumberish)[],
      _amounts: (BigNumberish)[],
      _data: BytesLike
    ): Promise<PopulatedTransaction>;
    safeTransferFrom(
      _from: string,
      _to: string,
      _id: BigNumberish,
      _amount: BigNumberish,
      _data: BytesLike
    ): Promise<PopulatedTransaction>;
    setApprovalForAll(
      _operator: string,
      _approved: boolean
    ): Promise<PopulatedTransaction>;
    supportsInterface(_interfaceID: BytesLike): Promise<PopulatedTransaction>;
    metaSafeTransferFrom(
      _from: string,
      _to: string,
      _id: BigNumberish,
      _amount: BigNumberish,
      _isGasFee: boolean,
      _data: BytesLike
    ): Promise<PopulatedTransaction>;
    metaSafeBatchTransferFrom(
      _from: string,
      _to: string,
      _ids: (BigNumberish)[],
      _amounts: (BigNumberish)[],
      _isGasFee: boolean,
      _data: BytesLike
    ): Promise<PopulatedTransaction>;
    metaSetApprovalForAll(
      _owner: string,
      _operator: string,
      _approved: boolean,
      _isGasFee: boolean,
      _data: BytesLike
    ): Promise<PopulatedTransaction>;
    getNonce(_signer: string): Promise<PopulatedTransaction>;
  };
}
