/* Generated by ts-generator ver. 0.0.8 */
/* tslint:disable */

import {
  ethers,
  EventFilter,
  Signer,
  BigNumber,
  BigNumberish,
  PopulatedTransaction
} from "ethers";
import {
  Contract,
  ContractTransaction,
  CallOverrides
} from "@ethersproject/contracts";
import { BytesLike } from "@ethersproject/bytes";
import { Listener, Provider } from "@ethersproject/providers";
import { FunctionFragment, EventFragment, Result } from "@ethersproject/abi";

interface Ierc165Interface extends ethers.utils.Interface {
  functions: {
    "supportsInterface(bytes4)": FunctionFragment;
  };

  encodeFunctionData(
    functionFragment: "supportsInterface",
    values: [BytesLike]
  ): string;

  decodeFunctionResult(
    functionFragment: "supportsInterface",
    data: BytesLike
  ): Result;

  events: {};
}

export class Ierc165 extends Contract {
  connect(signerOrProvider: Signer | Provider | string): this;
  attach(addressOrName: string): this;
  deployed(): Promise<this>;

  on(event: EventFilter | string, listener: Listener): this;
  once(event: EventFilter | string, listener: Listener): this;
  addListener(eventName: EventFilter | string, listener: Listener): this;
  removeAllListeners(eventName: EventFilter | string): this;
  removeListener(eventName: any, listener: Listener): this;

  interface: Ierc165Interface;

  functions: {
    /**
     * Interface identification is specified in ERC-165. This function uses less than 30,000 gas
     * Query if a contract implements an interface
     * @param _interfaceId The interface identifier, as specified in ERC-165
     */
    supportsInterface(
      _interfaceId: BytesLike,
      overrides?: CallOverrides
    ): Promise<{
      0: boolean;
    }>;
  };

  /**
   * Interface identification is specified in ERC-165. This function uses less than 30,000 gas
   * Query if a contract implements an interface
   * @param _interfaceId The interface identifier, as specified in ERC-165
   */
  supportsInterface(
    _interfaceId: BytesLike,
    overrides?: CallOverrides
  ): Promise<boolean>;

  staticCall: {
    /**
     * Interface identification is specified in ERC-165. This function uses less than 30,000 gas
     * Query if a contract implements an interface
     * @param _interfaceId The interface identifier, as specified in ERC-165
     */
    supportsInterface(
      _interfaceId: BytesLike,
      overrides?: CallOverrides
    ): Promise<boolean>;
  };

  filters: {};

  estimateGas: {
    supportsInterface(_interfaceId: BytesLike): Promise<BigNumber>;
  };

  populateTransaction: {
    supportsInterface(_interfaceId: BytesLike): Promise<PopulatedTransaction>;
  };
}
